using System;
using System.IO;
using System.Text;

namespace ExtendReplacer
{
	/// <summary>
	/// Class1 ̊Tv̐łB
	/// </summary>
	class Class1
	{
		
		private static string InnerReplaceFilePath = string.Empty;
		private static string InnerDefineFilePath = string.Empty;
		private static bool InnerIsRevers = false;
		private static Encoding InnerEncoding = Encoding.Default;
		private static Encoding InnerEncoding2 = Encoding.Default;
		
		/// <summary>
		/// 
		/// </summary>
		/// <param name="args">
		///		<para>[0] : uΏۃt@CpX [K{]</para>
		///		<para>[1] : u`t@CpX [K{]</para>
		///		<para>[2] : </para>
		/// </param>
		[STAThread]
		static void Main(string[] args)
		{
			// wb_o
			WriteHeader();
			
			// Q̏ꍇ̓CtH[V\
			if (args.Length < 2)
			{
				WriteInformation();
				return;
			}
			
			// p[^擾
			GetParamatrers(args, out InnerReplaceFilePath, out InnerDefineFilePath, out InnerIsRevers, out InnerEncoding, out InnerEncoding2);
			
			// G[̏ꍇ͎gpo͂ďI
			if (ErrorCheck())
			{
				return;
			}
			
			// Jn
			ExtendReplacer per = new ExtendReplacer(InnerReplaceFilePath, InnerDefineFilePath, InnerIsRevers);
			per.ReplaceFileEncoding = InnerEncoding;
			per.DefineFileEncoding = InnerEncoding2;
			per.Replace();
			
			// G[`FbN
			if (per.ErrorMessage.Length > 0)
			{
				Console.WriteLine("");
				Console.WriteLine(per.ErrorMessage);
			}
			else
			{
				Console.WriteLine("");
				Console.WriteLine("Done.");
			}
			Console.WriteLine("");
		}
		
		#region private static void GetParamatrers(string[] args, out string replaceFilePath, out string defineFilePath, out bool isRevers, out Encoding useEncoding)
		/// <summary>
		///		p[^擾
		/// </summary>
		/// <param name="args">p[^i[z</param>
		/// <param name="replaceFilePath">uΏۃt@CpX</param>
		/// <param name="defineFilePath">u`t@CpX</param>
		/// <param name="isRevers">tutO</param>
		/// <param name="replaceFileEncoding">GR[h@</param
		/// <param name="defineFileEncoding">GR[h@</param>
		private static void GetParamatrers(string[] args, out string replaceFilePath, out string defineFilePath, out bool isRevers, out Encoding replaceFileEncoding, out Encoding defineFileEncoding)
		{
			replaceFilePath = string.Empty;
			defineFilePath = string.Empty;
			isRevers = false;
			replaceFileEncoding = Encoding.Default;
			defineFileEncoding = Encoding.Default;
			
			if (args.Length >= 2)
			{
				replaceFilePath = args[0].Trim('"');
				defineFilePath = args[1].Trim('"');
			}
			
			foreach (string s in args)
			{
				if (String.Compare(s.Trim(), "-desc", true) == 0)
				{
					isRevers = true;
				}
				
				
				if (String.Compare(s.Trim(), "-r:sjis", true) == 0)
				{
					replaceFileEncoding = Encoding.GetEncoding(932);
				}
				
				if (String.Compare(s.Trim(), "-r:utf8", true) == 0)
				{
					replaceFileEncoding = Encoding.UTF8;
				}
				
				
				if (String.Compare(s.Trim(), "-d:sjis", true) == 0)
				{
					defineFileEncoding = Encoding.GetEncoding(932);
				}
				
				if (String.Compare(s.Trim(), "-d:utf8", true) == 0)
				{
					defineFileEncoding = Encoding.UTF8;
				}
			}
		}
		#endregion
		
		#region private static bool ErrorCheck()
		private static bool ErrorCheck()
		{
			if (!File.Exists(InnerReplaceFilePath))
			{
				Console.Write("");
				Console.Write("uΏۃt@C݂܂B");
				Console.Write("");
				return true;
			}
			
			if (!File.Exists(InnerDefineFilePath))
			{
				Console.Write("");
				Console.Write("`t@C݂܂B");
				Console.Write("");
				return true;
			}
			
			return false;
		}
		#endregion
		
		#region private static void WriteHeader()
		private static void WriteHeader()
		{
			System.Version currentVersion = System.Reflection.Assembly.GetExecutingAssembly().GetName().Version;
			
			Console.Write("Text File Extend Replacer Version ");
			Console.Write(currentVersion.Major.ToString());
			Console.Write(".");
			Console.Write(currentVersion.Minor.ToString());
			Console.Write(" Build ");
			Console.Write(currentVersion.Build.ToString());
			Console.WriteLine();
			Console.WriteLine("Copyright 2004 (C) ndoc-jp Project.");
		}
		#endregion
		
		#region private static void WriteInformation()
		private static void WriteInformation()
		{
			Console.WriteLine();
			Console.WriteLine("w肳ꂽt@C`t@Cɏ]Ēu܂");
			Console.WriteLine();
			Console.WriteLine("ExtendReplacer uΏۃt@C `t@C [-desc] [-r:sjis] [-r:utf8] [-d:sjis] [-d:utf8]");
			Console.WriteLine();
			Console.WriteLine("  uΏۃt@C ust@CpX");
			Console.WriteLine("  `t@C     us`t@C");
			Console.WriteLine("  -desc            tuIvV");
			Console.WriteLine("  -r:sjis          uΏۃt@CShiftJISœǂݏ܂B");
			Console.WriteLine("  -r:utf8          uΏۃt@CUTF-8 œǂݏ܂B");
			Console.WriteLine("  -d:sjis          u`t@CShiftJISŊJ܂B");
			Console.WriteLine("  -d:utf8          u`t@CUTF-8 ŊJ܂B");
			Console.WriteLine();
		}
		#endregion
		
		
	}
}
